#!/usr/bin/env python

from egg import App, eggify, GPL

class FileViewLCA2007(App):
  """A file viewer example for LCA2007!"""

  filename = eggify(None)

  @eggify
  def open(self, filename):
    """Open a file (read-only)"""
    file = open(filename)
    print "".join(file.readlines()[0:3]) + "..."
    file.close()
    self.feedback(filename + " opened.")
    self.filename = filename

  @eggify(context=filename)
  def close(self):
    """Close the current file"""
    self.feedback(self.filename.target + " closed.")
    self.filename = None

  def __init__(self):
    App.__init__(self,
                   menu = [["_File", self.open, self.close, None, self.quit],
                            ["_Help", self.about]],
                   tools = [self.open, self.close, self.quit],
                   version = "1.0",
                   authors = ["Pete Ryland <pdr@pdr.cx"],
                   copyright = "Copyright (c) 2007 Pete Ryland",
                   license = GPL
                )

if __name__ == "__main__":
  a = FileViewLCA2007()
  a()
