#!/usr/bin/python

from egg import App, eggify, GPL
import gtk

class FileViewLCA2007(App):
  """A file viewer example application for LCA2007!"""

  filename = eggify(None)

  @eggify()
  def open(self, filename):
    """Open a file (read-only)"""
    file = open(filename)
    mytext = "".join(file.readlines())
    file.close()
    self.textbuffer.set_text(mytext)
    self.textbuffer.apply_tag(self.mytexttag, self.textbuffer.get_start_iter(), self.textbuffer.get_end_iter())
    self.feedback(filename + " opened.")
    self.filename = filename

  @eggify(context=filename)
  def close(self):
    """Close the current file"""
    self.textbuffer.set_text("")
    self.feedback(self.filename.target + " closed.")
    self.filename = None

  def __init__(self):
    App.__init__(self,
                     menu=[["_File", self.open, self.close, None, self.quit],
                           ["_Help", self.about]],
                     tools=[self.open, self.close, self.quit],
                     version="1.0",
                     authors=["Pete Ryland <pdr@pdr.cx>"],
                     copyright="Copyright (c) 2007 Pete Ryland",
                     license=GPL
                    )
    self.mytexttag = gtk.TextTag()
    self.mytexttag.props.family = "Monospace"
    self.textbuffer = gtk.TextBuffer()
    self.textbuffer.get_tag_table().add(self.mytexttag)
    textview = gtk.TextView(self.textbuffer)
    scrolltextview = gtk.ScrolledWindow()
    scrolltextview.add(textview)
    scrolltextview.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    self.set_contents(scrolltextview)

if __name__ == "__main__":
  a=FileViewLCA2007()
  a()
